diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-txop-test.cc ns-3.42/src/wifi/test/wifi-txop-test.cc
--- ns-3.41/src/wifi/test/wifi-txop-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-txop-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -356,92 +510,124 @@
      * fails. Also, verify that a CF-end frame is sent if enough time remains in the TXOP.
      * The destination of failed frames is put in square brackets below.
      *
-     *          |---NAV-----till end TXOP--------->|
-     *          |      |----NAV--till end TXOP---->|
-     *          |      | |---------------------------NAV---------------------------------->| | | |
-     * |--------------------------NAV---------------------------->| |      |              |      |
-     * |------------------------NAV----------------------->| |      |              |      |      |
-     * |-------------NAV--------------->| Start|      |         Start|      |      | |
-     * |----------NAV----------->| TXOP |      |         TXOP |      |      |   Ack            | |
-     * |-------NAV------->| |   |      |          |   |      |      | Timeout          |      | |
-     * |---NAV---->|
-     *      |---|  |---|-backoff->|---|  |---|  |---|   |-PIFS or->|---|  |---|  |---|  |---|
-     * |-----| |QoS|  |Ack|          |QoS|  |Ack|  |QoS|   |-backoff->|QoS|  |Ack|  |QoS|  |Ack|
-     * |CFend|
-     * ----------------------------------------------------------------------------------------------------
-     * From:  AP    STA1            AP    STA1    AP                 AP    STA2    AP    STA3    AP
-     *   To: STA1   [AP]           STA1    AP   [STA2]              STA2    AP    STA3    AP     all
+     *          |--NAV----till end TXOP-------->|
+     *          |     |---NAV--till end TXOP--->|
+     *          |     |              |-------------------------NAV------------------------------>|
+     *          |     |              |     |------------------------NAV------------------------->|
+     *          |     |              |     |     |-----------------------NAV-------------------->|
+     *          |     |              |     |     |                  |-----------NAV------------->|
+     *     Start|     |         Start|     |     |                  |     |--------NAV---------->|
+     *     TXOP |     |         TXOP |     |     |   Ack            |     |     |------NAV------>|
+     *      |   |     |          |   |     |     | Timeout          |     |     |     |---NAV--->|
+     *      |---| |---|-backoff->|---| |---| |---|   |-PIFS or->|---| |---| |---| |---| |-----|
+     *      |QoS| |Ack|          |QoS| |Ack| |QoS|   |-backoff->|QoS| |Ack| |QoS| |Ack| |CFend|
+     * --------------------------------------------------------------------------------------------
+     * From:  AP   STA1            AP   STA1   AP                 AP   STA2   AP   STA3   AP
+     *   To: STA1  [AP]           STA1   AP  [STA2]              STA2   AP   STA3   AP    all
      */
 
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus.size(), 25, "Expected 25 transmitted frames");
+    // We expect 25 frames to be transmitted if SingleRtsPerTxop is false and 22 frames (2 RTS
+    // less, 2 CTS less, 1 more CF-End)
+    NS_TEST_ASSERT_MSG_EQ(m_txPsdus.size(),
+                          (m_singleRtsPerTxop ? 22 : 25),
+                          "Unexpected number of transmitted frames");
 
-    // the first frame sent after 400ms is a QoS data frame sent by the AP to STA1
+    // the first frame sent after 400ms is a QoS data frame sent by the AP to STA1 without RTS/CTS
     txopStart = m_txPsdus[0].txStart;
 
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[0].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[0].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[0].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[0].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the first station");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[0].header.GetDuration(),
-                          RoundDurationId(m_txopLimit - m_txPsdus[0].txDuration),
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[0].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[0].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[0].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - m_txPsdus[0].txDuration),
                           "Duration/ID of the first frame must cover the whole TXOP");
 
     // a Normal Ack is sent by STA1
     tEnd = m_txPsdus[0].txStart + m_txPsdus[0].txDuration;
     tStart = m_txPsdus[1].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the first frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the first frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "Ack in response to the first frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[1].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[1].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[1].header.IsAck(), true, "Expected a Normal Ack");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[1].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[1].header.GetDuration(),
         RoundDurationId(m_txPsdus[0].header.GetDuration() - sifs - m_txPsdus[1].txDuration),
         "Duration/ID of the Ack must be derived from that of the first frame");
 
     // the AP receives a corrupted Ack in response to the frame it sent, which is the initial
     // frame of a TXOP. Hence, the TXOP is terminated and the AP retransmits the frame after
-    // invoking the backoff
+    // waiting for EIFS - DIFS + AIFS + backoff (see section 10.3.2.3.7 of 802.11-2020)
     txopStart = m_txPsdus[2].txStart;
 
     tEnd = m_txPsdus[1].txStart + m_txPsdus[1].txDuration;
     tStart = m_txPsdus[2].txStart;
 
-    NS_TEST_ASSERT_MSG_GT_OR_EQ(
+    auto apPhy = apDev->GetPhy(SINGLE_LINK_OP_ID);
+    auto eifsNoDifs = apPhy->GetSifs() + apPhy->GetAckTxTime();
+
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(
         tStart - tEnd,
-        sifs + m_aifsn * slot,
+        eifsNoDifs + sifs + aifsn * slot,
         "Less than AIFS elapsed between AckTimeout and the next TXOP start");
-    NS_TEST_ASSERT_MSG_LT_OR_EQ(
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(
         tStart - tEnd,
-        sifs + m_aifsn * slot + (2 * (m_cwMin + 1) - 1) * slot,
+        eifsNoDifs + sifs + aifsn * slot + (2 * (cwMin + 1) - 1) * slot,
         "More than AIFS+BO elapsed between AckTimeout and the next TXOP start");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[2].header.IsQosData(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[2].header.IsQosData(),
                           true,
                           "Expected to retransmit a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[2].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[2].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected to retransmit a frame to the first station");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[2].header.GetDuration(),
-                          RoundDurationId(m_txopLimit - m_txPsdus[2].txDuration),
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[2].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[2].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[2].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - m_txPsdus[2].txDuration),
                           "Duration/ID of the retransmitted frame must cover the whole TXOP");
 
     // a Normal Ack is then sent by STA1
     tEnd = m_txPsdus[2].txStart + m_txPsdus[2].txDuration;
     tStart = m_txPsdus[3].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the first frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the first frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "Ack in response to the first frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[3].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[3].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[3].header.IsAck(), true, "Expected a Normal Ack");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[3].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[3].header.GetDuration(),
         RoundDurationId(m_txPsdus[2].header.GetDuration() - sifs - m_txPsdus[3].txDuration),
         "Duration/ID of the Ack must be derived from that of the previous frame");
@@ -450,65 +636,94 @@
     tEnd = m_txPsdus[3].txStart + m_txPsdus[3].txDuration;
     tStart = m_txPsdus[4].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Second frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[4].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[4].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Second frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[4].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[4].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the second station");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[4].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[4].txStart - txopStart) - m_txPsdus[4].txDuration),
-        "Duration/ID of the second frame does not cover the remaining TXOP");
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[4].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[4].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[4].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - (m_txPsdus[4].txStart - txopStart) -
+                                          m_txPsdus[4].txDuration),
+                          "Duration/ID of the second frame does not cover the remaining TXOP");
 
     // STA2 receives a corrupted frame and hence it does not send the Ack. When the AckTimeout
     // expires, the AP performs PIFS recovery or invoke backoff, without terminating the TXOP,
     // because a non-initial frame of the TXOP failed
+    auto apStationManager = apDev->GetRemoteStationManager(SINGLE_LINK_OP_ID);
+    auto staAddress = DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress();
+    auto ackTxVector = apStationManager->GetAckTxVector(staAddress, m_txPsdus[4].txVector);
     tEnd = m_txPsdus[4].txStart + m_txPsdus[4].txDuration + sifs + slot +
-           WifiPhy::CalculatePhyPreambleAndHeaderDuration(m_txPsdus[4].txVector); // AckTimeout
+           WifiPhy::CalculatePhyPreambleAndHeaderDuration(ackTxVector); // AckTimeout
     tStart = m_txPsdus[5].txStart;
 
     if (m_pifsRecovery)
     {
-        NS_TEST_ASSERT_MSG_EQ(tEnd + sifs + slot,
+        NS_TEST_EXPECT_MSG_EQ(tEnd + sifs + slot,
                               tStart,
                               "Second frame must have been sent after a PIFS");
     }
     else
     {
-        NS_TEST_ASSERT_MSG_GT_OR_EQ(
+        NS_TEST_EXPECT_MSG_GT_OR_EQ(
             tStart - tEnd,
-            sifs + m_aifsn * slot,
+            sifs + aifsn * slot,
             "Less than AIFS elapsed between AckTimeout and the next transmission");
-        NS_TEST_ASSERT_MSG_LT_OR_EQ(
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(
             tStart - tEnd,
-            sifs + m_aifsn * slot + (2 * (m_cwMin + 1) - 1) * slot,
+            sifs + aifsn * slot + (2 * (cwMin + 1) - 1) * slot,
             "More than AIFS+BO elapsed between AckTimeout and the next TXOP start");
     }
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[5].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[5].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[5].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[5].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the second station");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[5].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[5].txStart - txopStart) - m_txPsdus[5].txDuration),
-        "Duration/ID of the second frame does not cover the remaining TXOP");
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[5].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[5].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[5].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - (m_txPsdus[5].txStart - txopStart) -
+                                          m_txPsdus[5].txDuration),
+                          "Duration/ID of the second frame does not cover the remaining TXOP");
 
     // a Normal Ack is then sent by STA2
     tEnd = m_txPsdus[5].txStart + m_txPsdus[5].txDuration;
     tStart = m_txPsdus[6].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
                           "Ack in response to the second frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "Ack in response to the second frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[6].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[6].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[6].header.IsAck(), true, "Expected a Normal Ack");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[6].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[6].header.GetDuration(),
         RoundDurationId(m_txPsdus[5].header.GetDuration() - sifs - m_txPsdus[6].txDuration),
         "Duration/ID of the Ack must be derived from that of the previous frame");
@@ -517,30 +732,43 @@
     tEnd = m_txPsdus[6].txStart + m_txPsdus[6].txDuration;
     tStart = m_txPsdus[7].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Third frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[7].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[7].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Third frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[7].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[7].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(2))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the third station");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[7].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[7].txStart - txopStart) - m_txPsdus[7].txDuration),
-        "Duration/ID of the third frame does not cover the remaining TXOP");
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[7].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[7].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[7].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - (m_txPsdus[7].txStart - txopStart) -
+                                          m_txPsdus[7].txDuration),
+                          "Duration/ID of the third frame does not cover the remaining TXOP");
 
     // a Normal Ack is then sent by STA3
     tEnd = m_txPsdus[7].txStart + m_txPsdus[7].txDuration;
     tStart = m_txPsdus[8].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the third frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Ack in response to the third frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "Ack in response to the third frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[8].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[8].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[8].header.IsAck(), true, "Expected a Normal Ack");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[8].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[8].header.GetDuration(),
         RoundDurationId(m_txPsdus[7].header.GetDuration() - sifs - m_txPsdus[8].txDuration),
         "Duration/ID of the Ack must be derived from that of the previous frame");
@@ -549,10 +777,10 @@
     tEnd = m_txPsdus[8].txStart + m_txPsdus[8].txDuration;
     tStart = m_txPsdus[9].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "CF-End sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[9].header.IsCfEnd(), true, "Expected a CF-End frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[9].header.GetDuration(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CF-End sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[9].header.IsCfEnd(), true, "Expected a CF-End frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[9].header.GetDuration(),
                           Seconds(0),
                           "Duration/ID must be set to 0 for CF-End frames");
 
@@ -560,32 +788,45 @@
     tEnd = m_txPsdus[9].txStart + m_txPsdus[9].txDuration;
     tStart = m_txPsdus[10].txStart;
 
-    NS_TEST_ASSERT_MSG_GT_OR_EQ(tStart - tEnd,
-                                sifs + m_aifsn * slot,
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(tStart - tEnd,
+                                sifs + m_staAifsn * slot,
                                 "Less than AIFS elapsed between two TXOPs");
-    NS_TEST_ASSERT_MSG_LT_OR_EQ(tStart - tEnd,
-                                sifs + m_aifsn * slot + m_cwMin * slot + tolerance,
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(tStart - tEnd,
+                                sifs + m_staAifsn * slot + m_staCwMin * slot + tolerance,
                                 "More than AIFS+BO elapsed between two TXOPs");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[10].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[10].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[10].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[10].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a frame sent by the first station to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_LT(m_txPsdus[10].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected not to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_LT(
+            m_txPsdus[10].txDuration,
+            rtsCtsTxDurationThresh,
+            "PSDU duration expected not to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[10].header.GetDuration(),
-        RoundDurationId(m_txopLimit - m_txPsdus[10].txDuration),
+        RoundDurationId(m_staTxopLimit - m_txPsdus[10].txDuration),
         "Duration/ID of the frame sent by the first station does not cover the remaining TXOP");
 
     // a Normal Ack is then sent by the AP
     tEnd = m_txPsdus[10].txStart + m_txPsdus[10].txDuration;
     tStart = m_txPsdus[11].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Ack sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Ack sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[11].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[11].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Ack sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Ack sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].header.IsAck(), true, "Expected a Normal Ack");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected a Normal Ack sent to the first station");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[11].header.GetDuration(),
         RoundDurationId(m_txPsdus[10].header.GetDuration() - sifs - m_txPsdus[11].txDuration),
         "Duration/ID of the Ack must be derived from that of the previous frame");
@@ -594,17 +835,17 @@
     tEnd = m_txPsdus[11].txStart + m_txPsdus[11].txDuration;
     tStart = m_txPsdus[12].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "CF-End sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[12].header.IsCfEnd(), true, "Expected a CF-End frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[12].header.GetDuration(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CF-End sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[12].header.IsCfEnd(), true, "Expected a CF-End frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[12].header.GetDuration(),
                           Seconds(0),
                           "Duration/ID must be set to 0 for CF-End frames");
 
     /*
      * Verify that the Duration/ID of RTS/CTS frames is set correctly, that the TXOP holder is
      * kept and allows stations to ignore NAV properly and that the CF-End Frame is not sent if
-     * not enough time remains
+     * not enough time remains. If SingleRtsPerTxop is set to true, only one RTS/CTS is sent.
      *
      *          |---------------------------------------------NAV---------------------------------->|
      *          | |-----------------------------------------NAV------------------------------->| |
@@ -627,30 +868,31 @@
 
     // the first frame is an RTS frame sent by the AP to STA1
     txopStart = m_txPsdus[13].txStart;
+    std::string ack(m_nonHt ? "Normal Ack" : "Block Ack");
 
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[13].header.IsRts(), true, "Expected an RTS frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[13].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].header.IsRts(), true, "Expected an RTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected an RTS frame sent by the AP to the first station");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[13].header.GetDuration(),
-                          RoundDurationId(m_txopLimit - m_txPsdus[13].txDuration),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[13].header.GetDuration(),
+                          RoundDurationId(m_apTxopLimit - m_txPsdus[13].txDuration),
                           "Duration/ID of the first RTS frame must cover the whole TXOP");
 
     // a CTS is sent by STA1
     tEnd = m_txPsdus[13].txStart + m_txPsdus[13].txDuration;
     tStart = m_txPsdus[14].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
                           "CTS in response to the first RTS frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "CTS in response to the first RTS frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[14].header.IsCts(), true, "Expected a CTS");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[14].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].header.IsCts(), true, "Expected a CTS");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[14].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
                           "Expected a CTS frame sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[14].header.GetDuration(),
         RoundDurationId(m_txPsdus[13].header.GetDuration() - sifs - m_txPsdus[14].txDuration),
         "Duration/ID of the CTS frame must be derived from that of the RTS frame");
